local TICRATE = TICRATE
local FRACUNIT = FRACUNIT

addHook("ThinkFrame", function()
	if not (JUICEBOX.value or JUICEBOX_forcefastrespawn.value) then return end
	for p in players.iterate
		if not (p.mo and p.mo.valid) then continue end
		if p.spectator then continue end
		
		local mo = p.mo
		local ks = p.kartstuff

		p.JBhascontrol = $ or 0
		p.JBqrok = $ or false

		if (p.kartstuff[k_spinouttimer] or p.kartstuff[k_squishedtimer]) then
			p.JBQRok = true
			p.JBhascontrol = 0
		else
			if P_IsObjectOnGround(mo) then -- if we somehow recover from spinout in midair (water?), extend leniency
				p.JBhascontrol = $ + 1 -- i think in airpunt situations this might give you a free MT while already moving forward
			else -- but airtechs already do this so what the fuck ever, can't control for everything and the gains > the losses
				continue -- (also make sure you can't blow your QR in the air, idiot)
			end
			if (p.JBhascontrol < TICRATE*3) and p.JBQRok and p.cmd.buttons & BT_ACCELERATE and not (p.cmd.buttons & BT_BRAKE) then
				-- we should never branch here with a loss-of-control flag set, so no need to actually recover the player
				ks[k_driftboost] = 21
				JUICEBOX_StartLocalSoundWithScaledVolumeInThisGorillaSpaghettiSplitscreenSystem(sfx_s23c, p)
				p.JBQRok = false
			end
		end

	end
end)