-- JUICEBOX "Grow Refund"
-- Awards a short miniturbo when canceling Grow.
-- Duration depends on remaining Grow timer.

addHook("ThinkFrame", function()
	if not JUICEBOX.value then return end
	for p in players.iterate
		if not (p.mo and p.mo.valid) then continue end
		if p.spectator then continue end
		local mo = p.mo
		local ks = p.kartstuff
		if p.JBlastgst and p.JBlastgst > 1 and not ks[k_growshrinktimer] then
			JUICEBOX_Stack(p, min(40, 2*p.JBlastgst/3))
			S_StartSound(mo, sfx_s23c)
		end
		p.JBlastgst = ks[k_growshrinktimer]
	end
end)