-- previously cvars for testing purposes, intentionally removed
local jb_manta_turbo = {value = 40}
local jb_manta_spacing = {value = 5000}
local jb_manta_spacescale = {value = 250}
local jb_manta_size = {value = 62500}
local jb_manta_sizescale = {value = 8192}
local jb_manta_grace = {value = 10}
local jb_manta_sizeup = {value = 10}
local jb_manta_sizestrength = {value = 1500}
local jb_manta_itemcut = {value = 100}
local jb_manta_grow = {value = 18}
local jb_manta_haste = {value = true}
local jb_manta_racetime = {value = 90}
local jb_manta_collide = {value = 80}
local jb_manta_maxramp = {value = 80}
local jb_manta_nspower = {value = 10}
local jb_manta_nsstrong = {value = 20}
local jb_manta_nsweak = {value = 36}
local jb_manta_fastramp = {value = 17}
local jb_manta_minpwr = {value = 10}
local TICRATE = TICRATE
local FRACUNIT = FRACUNIT
local STARTTIME = 6*TICRATE + (3*TICRATE/4)

freeslot("sfx_gatefx")
freeslot("sfx_mnsrc")
freeslot("MT_MANTARING")
freeslot("MT_MANTADROP")
freeslot("S_MANTA1")
freeslot("S_MANTA2")
freeslot("S_MANTADROP")
freeslot("SPR_TRIS")
freeslot("SPR_TRNQ")
freeslot("SPR_TRIS")
freeslot("SPR_TRDS")
mobjinfo[MT_MANTARING] = {
	spawnstate = S_MANTA1,
	flags = MF_NOGRAVITY|MF_NOCLIPHEIGHT,
	radius = 64*FRACUNIT
}
states[S_MANTA1] = {
	sprite = SPR_TRIS,
	frame = A|FF_FULLBRIGHT|FF_ANIMATE|FF_PAPERSPRITE|FF_TRANS20,
	tics = 9,
	var1 = 2,
	var2 = 3,
	nextstate = S_MANTA2
}
states[S_MANTA2] = {
	sprite = SPR_TRNQ,
	frame = A|FF_FULLBRIGHT|FF_ANIMATE|FF_PAPERSPRITE|FF_TRANS20,
	var1 = 11,
	var2 = 3
}
mobjinfo[MT_MANTADROP] = {
	spawnstate = S_MANTADROP,
	flags = MF_NOGRAVITY|MF_NOCLIPHEIGHT,
	radius = 64*FRACUNIT
}
states[S_MANTADROP] = {
	sprite = SPR_TRDS,
	frame = A|FF_FULLBRIGHT|FF_ANIMATE|FF_PAPERSPRITE|FF_TRANS20,
	var1 = 5,
	var2 = 3
}


addHook("MobjSpawn", function(mo)
	mo.boostval = jb_manta_turbo.value
	-- doing what TSR does except not really
	local delay = max(15, jb_manta_racetime.value/mapheaderinfo[gamemap].numlaps)
	if mapheaderinfo[gamemap].levelflags & LF_SECTIONRACE
		delay = 60
	end
	mo.threshold = delay*TICRATE
	mo.colorized = true
end, MT_MANTARING)
addHook("MobjThinker", function(mo)
	mo.color = mo.ownercolor
	if JUICEBOX_dp and JUICEBOX_dp.valid and JUICEBOX_dp.touchedgates then
	
		if (mo.owner == JUICEBOX_dp and (not splitscreen)) then 
			mo.flags2 = $|MF2_DONTDRAW
		else
			if (JUICEBOX_dp.touchedgates[mo.gateid]) and ((JUICEBOX_dp.touchedgates[mo.gateid]) < (leveltime - 5*TICRATE)) and (not splitscreen) then
				mo.flags2 = $|MF2_DONTDRAW
			else
				mo.flags2 = $&(~MF2_DONTDRAW)
			end
		end
		
		local alivegate = FF_TRANS40
		local deadgate = FF_TRANS80
		
		if ((JUICEBOX_dp.touchedgates[mo.gateid] or JUICEBOX_dp.kartstuff[k_position] == 1) and (not splitscreen)) then
			mo.frame = $&(~FF_TRANSMASK)|deadgate
		else
			mo.frame = $&(~FF_TRANSMASK)|alivegate
		end
		
	end
	-- if consoleplayer and consoleplayer.touchedgates[mo.gateid] then mo.flags2 = $|MF2_SHADOW else mo.flags2 = $&(~MF2_SHADOW) end
	if mo.state == S_MANTA2 and not mo.dropshadow then
		local dsd = FixedMul(32*FRACUNIT, mapheaderinfo[gamemap].mobj_scale)
		local tx, ty, tz = mo.x - FixedMul(dsd, cos(mo.angle + ANGLE_90)), mo.y - FixedMul(dsd, sin(mo.angle + ANGLE_90)), mo.z
		mo.dropshadow = P_SpawnMobj(tx, ty, tz, MT_MANTADROP)
		mo.dropshadow.target = mo
		mo.dropshadow.color = mo.ownercolor
		mo.dropshadow.angle = mo.angle
		mo.dropshadow.scale = mo.scale
		mo.dropshadow.flags2 = mo.flags2
	end
	mo.threshold = $ - 1
	if not mo.threshold then P_RemoveMobj(mo)
	else
		if not (mo.threshold % jb_manta_sizeup.value) then
			mo.destscale = mo.scale + jb_manta_sizestrength.value
			mo.boostval = min(jb_manta_maxramp.value, $ + 1)
		end
	end
end, MT_MANTARING)

-- WOW this is uncommonly ugly fix later
-- EDIT: never mind
addHook("MobjThinker", function(mo)
	if not (mo and mo.valid) then return end
	local thing = mo
	mo.timealive = $ or 0
	mo.timealive = $ + 1
	for p in players.iterate
		if not (p.mo and p.mo.valid) then continue end
		local tmthing = p.mo
		local dx, dy, dz = abs(tmthing.x - thing.x), abs(tmthing.y - thing.y), abs(tmthing.z - thing.z)
		local distance = P_AproxDistance(P_AproxDistance(dx, dy),dz) - (tmthing.radius) - (thing.radius)
		if abs(distance) > jb_manta_collide.value*FRACUNIT then continue end
		
		if thing.owner == tmthing.player then continue end
		if (tmthing.player.touchedgates and tmthing.player.touchedgates[thing.gateid])
		or (tmthing.player.kartstuff[k_position] == 1) then
			continue
		end
		local addboost
		if tmthing.player.kartstuff[k_growshrinktimer] > 0 then
			addboost = jb_manta_grow.value
		elseif tmthing.player.kartstuff[k_itemamount] > 0 then
			addboost = (jb_manta_itemcut.value * thing.boostval / 100)
		else
			addboost = thing.boostval
		end
		--print(addboost)
		local holding = tmthing.player.gatedecay * addboost / 100
		--print(holding)
		if jb_manta_haste.value then
			local p = tmthing.player
			local accel = max(0, (9 - p.kartspeed - p.kartweight/2))
			local target = (26*4 + p.kartspeed*2)*8
			local bonusfactor = FixedDiv((130 - 100)*FRACUNIT, 100*FRACUNIT)
			local diefactor = FRACUNIT + FixedMul(FixedDiv(bonusfactor, FRACUNIT*8), accel*FRACUNIT)
			holding = FixedInt(FixedMul(holding*FRACUNIT, diefactor))
		end
		
		if thing.timealive < jb_manta_fastramp.value then
			--print("going in: "..holding)
			holding = max(jb_manta_minpwr.value, FixedInt(FixedMul(FixedDiv(thing.timealive*FRACUNIT, jb_manta_fastramp.value*FRACUNIT), $*FRACUNIT)))
			--print("coming out: "..holding)
		end
		
		JUICEBOX_Stack(tmthing.player, holding, true)
		tmthing.player.techedrecently = TICRATE/4
		JUICEBOX_StartLocalSoundWithScaledVolumeInThisGorillaSpaghettiSplitscreenSystem(sfx_gatefx, p)
		if p.JBlocal and not (splitscreen or JUICEBOX_reducemotion.value) then
			P_StartQuake(FRACUNIT*12, 6)
		end
		tmthing.player.touchedgates[thing.gateid] = leveltime
		continue
	end
end, MT_MANTARING)

addHook("MobjThinker", function(mo)
	if (not mo.target) or (not mo.target.valid) then
		P_RemoveMobj(mo) 
	else
		mo.scale = mo.target.scale
		mo.flags2 = mo.target.flags2
		if JUICEBOX_renderer != "software" then
			mo.frame = $|(mo.target.frame & FF_TRANSMASK)
		end
	end
end, MT_MANTADROP)

local gateid
local totaldist
local gamespeed
addHook("NetVars", function(net)
	gateid = net(gateid)
	totaldist = net(totaldist)
	gamespeed = net(gamespeed)
end)

addHook("ThinkFrame", function()
	if not JUICEBOX.value then return end
	if leveltime == 0 then return end
	if leveltime == 1 then
		totaldist = 30000
		gateid = 1
		gamespeed = CV_FindVar("kartspeed").value
		for p in players.iterate
			p.touchedgates = {}
			p.gatedecay = 100
			p.gatebarhappy = 100
		end
	end
	local didfirst = false
	-- shoutouts to aqua and jugador, you fucks LMAO
	-- nice catch but y'all nearly gave me a heart attack
	-- if JUICEBOX_netdebug.value then jb_manta_grace.value = 1 end
	for p in players.iterate
		if not (p.mo and p.mo.valid) then continue end
		if p.spectator then continue end
		if not (p.touchedgates) then p.touchedgates = {} end
		local mo = p.mo
		local ks = p.kartstuff
		p.gatedecay = $ or 100
		p.gatebarhappy = $ or 0
		if ks[k_itemtype] and ks[k_itemamount] then 
			local it = ks[k_itemtype] 
			local ia = ks[k_itemamount]
			local dcheck = jb_manta_nsweak.value
			if it == KITEM_ROCKETSNEAKER or it == KITEM_SHRINK or it == KITEM_GROW or it == KITEM_INVINCIBILITY or (it == KITEM_SNEAKER and ia >= 2) then
				dcheck = jb_manta_nspower.value
			elseif it == KITEM_HYUDORO or (it == KITEM_JAWZ and ia >= 2) or it == KITEM_BALLHOG or it == KITEM_SNEAKER  then
				dcheck = jb_manta_nsstrong.value
			end
			if (leveltime % dcheck) == 0 then
				p.gatedecay = max(10, $ - 1)
				if p.gatedecay == 62 then
					JUICEBOX_StartLocalSoundWithScaledVolumeInThisGorillaSpaghettiSplitscreenSystem(sfx_s3k7c, p)
					JUICEBOX_StartLocalSoundWithScaledVolumeInThisGorillaSpaghettiSplitscreenSystem(sfx_s3k7c, p)
				end
			end
			p.gatedecay = min(99, $) -- inelegant hack to make hud easier
		else
			p.gatedecay = min($+1, 100)
		end
		if p.gatedecay == 100 then
			if p.gatebarhappy == 0 then
			JUICEBOX_StartLocalSound(sfx_mnsrc, p)
			end
			p.gatebarhappy = $+1
		else
			p.gatebarhappy = 0
		end
		if ((leveltime <= (STARTTIME+TICRATE*jb_manta_grace.value)) and (not JUICEBOX_netdebug.value)) or ks[k_position] != 1 then continue end
		-- housekeeping's over, let's anger some frontrunners!
		if not didfirst then
			local spacing = jb_manta_spacing.value - p.kartspeed * jb_manta_spacescale.value
			if gamespeed == 1 then
				spacing = $ / 20 * 17 -- 85%
			elseif gamespeed == 0 then
				spacing = $ / 10 * 7 -- 70%
			end
			table.insert(JUICEBOX_dwatch, "SPC: "..spacing)
			totaldist = $ + abs(P_AproxDistance(mo.momx, mo.momy)) -- xd
			if totaldist > FixedMul(spacing*FRACUNIT, mapheaderinfo[gamemap].mobj_scale) and P_IsObjectOnGround(mo) then
				totaldist = 0
				local ring = P_SpawnMobj(mo.x, mo.y, mo.z, MT_MANTARING)
				ring.owner = p
				ring.color = p.skincolor
				ring.ownercolor = p.skincolor
				ring.ownerspeed = p.kartspeed
				ring.ownerweight = min(p.kartweight, JUICEBOX_weightadjust)
				ring.gateid = gateid
				if p == consoleplayer and (not splitscreen) then ring.flags2 = $|MF2_DONTDRAW else ring.flags2 = $&(~MF2_DONTDRAW) end
				ring.scale = FixedMul(mo.scale, jb_manta_size.value + jb_manta_sizescale.value*ring.ownerweight)
				ring.angle = R_PointToAngle2(0, 0, mo.momx, mo.momy) + ANGLE_90
				gateid = $ + 1
			end
			table.insert(JUICEBOX_dwatch, "SP: "..spacing)
			table.insert(JUICEBOX_dwatch, "TD: "..totaldist)
			didfirst = true
		end
	end
end)