-- JUICEBOX "Hyudoro Spy"
-- Allows Hyudoro users to see held items, including whether they're currently stealable.

local TICRATE = TICRATE
local FRACUNIT = FRACUNIT

-- as far as i'm concerned, this code is a black box. i do not care.
local function doFrameShit(p)
	local mobj = p.JBspy
	local flicker = false
	if not mobj.tracer then
		return
	end
	if p.kartstuff[k_itemroulette] then
		mobj.state = S_PLAYERARROW_BOX
		mobj.tracer.sprite = SPR_ITEM
		mobj.tracer.frame = FF_FULLBRIGHT|(((mobj.target.player.kartstuff[k_itemroulette] % (13*3)) / 3) + 1)
	elseif p.kartstuff[k_stolentimer] > 0 then
		mobj.state = S_PLAYERARROW_BOX
		mobj.tracer.sprite = SPR_ITEM
		mobj.tracer.frame = FF_FULLBRIGHT|KITEM_HYUDORO
		flicker = true
	elseif p.kartstuff[k_stealingtimer] > 0 and (leveltime % 2) then
		mobj.state = S_PLAYERARROW_BOX
		mobj.tracer.sprite = SPR_ITEM
		mobj.tracer.frame = FF_FULLBRIGHT|KITEM_HYUDORO
	elseif p.kartstuff[k_eggmanexplode] > 1 then
		mobj.state = S_PLAYERARROW_BOX
		mobj.tracer.sprite = SPR_ITEM
		mobj.tracer.frame = FF_FULLBRIGHT|KITEM_EGGMAN
		flicker = true
	elseif p.kartstuff[k_rocketsneakertimer] > 1 then
		mobj.state = S_PLAYERARROW_BOX
		mobj.tracer.sprite = SPR_ITEM
		mobj.tracer.frame = FF_FULLBRIGHT|KITEM_ROCKETSNEAKER
		flicker = true
	elseif p.kartstuff[k_growshrinktimer] > 0 then
		mobj.state = S_PLAYERARROW_BOX
		mobj.tracer.sprite = SPR_ITEM
		mobj.tracer.frame = FF_FULLBRIGHT|KITEM_GROW
	elseif p.kartstuff[k_itemtype] and p.kartstuff[k_itemamount] > 0 then
		mobj.state = S_PLAYERARROW_BOX
		if p.kartstuff[k_itemtype] == KITEM_ORBINAUT then
			mobj.tracer.sprite = SPR_ITMO
			mobj.tracer.frame = FF_FULLBRIGHT|(min(mobj.target.player.kartstuff[k_itemamount]-1, 3))
		elseif p.kartstuff[k_itemtype] == KITEM_INVINCIBILITY then
			mobj.tracer.sprite = SPR_ITMI
			mobj.tracer.frame = FF_FULLBRIGHT|((leveltime % (7*3)) / 3)
		elseif p.kartstuff[k_itemtype] == KITEM_SAD
			mobj.tracer.sprite = SPR_ITEM
			mobj.tracer.frame = FF_FULLBRIGHT
		else
			p.JBspy.tracer.sprite = SPR_ITEM
			p.JBspy.tracer.frame = FF_FULLBRIGHT|(p.kartstuff[k_itemtype])
		end
		if p.kartstuff[k_itemheld] then
			flicker = true
		end
	else
		p.JBspy.state = S_PLAYERARROW
		p.JBspy.tracer.flags2 = $|MF2_DONTDRAW
	end
	if flicker then
		if leveltime % 2 then
			-- p.JBspy.tracer.flags2 = $ & (~MF2_DONTDRAW)
		else
			p.JBspy.tracer.flags2 = $|MF2_DONTDRAW
		end
	end
end

local function spawnOverhead(p)
	p.JBspy = P_SpawnMobj(p.mo.x, p.mo.y, p.mo.z + P_GetPlayerHeight(p)+16*FRACUNIT, MT_PLAYERARROW)
	p.JBspy.target = p.mo
	p.JBspy.flags2 = $|MF2_DONTDRAW
end

addHook("ThinkFrame", function()
	if not JUICEBOX.value then return end
	for p in players.iterate
		if not (p.mo and p.mo.valid) then continue end
		if p.spectator then continue end
		local mo = p.mo
		local ks = p.kartstuff

		if p.playerstate == PST_LIVE then
			if not p.JBspy then
				spawnOverhead(p)
			elseif not p.JBspy.valid then
				spawnOverhead(p)
			end
		end
		
		if p.JBspy and p.JBspy.valid then -- gonna be honest, i have no idea how much of this will be done for me by hardcode
			-- p.JBspy.state = S_PLAYERARROW_BOX -- but 1) better safe than sorry, and
			p.JBspy.scale = FRACUNIT -- 2) i wanna fucking die
			-- p.JBspy.angle = R_PointToAngle(p.JBspy.x, p.JBspy.y) + ANGLE_90;
			p.JBspy.color = p.skincolor
			if JUICEBOX_dp and JUICEBOX_dp.valid and p.valid and p.JBspy.tracer and (not splitscreen) then
				p.JBspy.flags2 = $|MF2_DONTDRAW
				p.JBspy.tracer.flags2 = $|MF2_DONTDRAW
				if p.kartstuff[k_itemblink] then
					p.JBspy.flags2 = $|MF2_SHADOW
					p.JBspy.tracer.flags2 = $|MF2_SHADOW
				else
					p.JBspy.flags2 = $ & ~MF2_SHADOW
					p.JBspy.tracer.flags2 = $ & ~MF2_SHADOW				
				end
				if p != JUICEBOX_dp and p.playerstate == PST_LIVE and JUICEBOX_dp.kartstuff[k_itemtype] == KITEM_HYUDORO and ks[k_itemamount] then
					p.JBspy.flags2 = $ & (~MF2_DONTDRAW)
					p.JBspy.tracer.flags2 = $ & (~MF2_DONTDRAW)
				end
			end
			doFrameShit(p)
		end

	end
end)

hud.add(function(v, p, c)
	if not JUICEBOX.value then return end
	if not (JUICEBOX_dp and JUICEBOX_dp.mo and JUICEBOX_dp.mo.valid) then return end
	if JUICEBOX_dp.kartstuff[k_itemtype] != KITEM_HYUDORO then return end
	for dude in players.iterate -- xd
		if dude == JUICEBOX_dp then continue end
		if not (dude.mo and dude.mo.valid) then continue end
		if (not dude.kartstuff[k_itemtype]) or (dude.kartstuff[k_itemblink]) or (dude.kartstuff[k_itemheld]) then continue end
		v.drawOnMinimap(dude.mo.x, dude.mo.y, 2*FRACUNIT/3, v.cachePatch(K_GetItemPatch(dude.kartstuff[k_itemtype], true)))
	end
end)